--- clamav-devel-jm13/clamav-milter/clamav-milter.c	Wed Apr 21 08:52:56 2004
+++ clamav-devel-jm14/clamav-milter/clamav-milter.c	Wed Apr 21 09:03:57 2004
@@ -2182,37 +2182,21 @@
 		/*
 		 * Setup err as a list of recipients
 		 */
-		err = (char *)cli_malloc(1024);
-		ALLOC_CHECK("cli_malloc",err,1);
 
-		/*
-		 * Use snprintf rather than printf since we don't know the
-		 * length of privdata->from and may get a buffer overrun
-		 */
-		snprintf(err, 1023, "Intercepted virus from %s to",
+		sprintf_alloc(&err,"Intercepted virus from %s to",
 			privdata->from);
 
-		ptr = strchr(err, '\0');
-
-		i = 1024;
-
 		for(to = privdata->to; *to; to++) {
-			/*
-			 * Re-alloc if we are about run out of buffer space
-			 */
-			if(&ptr[strlen(*to) + 2] >= &err[i]) {
-				i += 1024;
-				p = NULL;
-				p = realloc(err, i);
-				ALLOC_CHECK("realloc",p,1);
-				err = p;
-				ptr = strchr(err, '\0');
-			}
-			ptr = strrcpy(ptr, " ");
-			ptr = strrcpy(ptr, *to);
+			ptr = NULL;
+			sprintf_alloc(&ptr,"%s %s",err,*to);
+			free(err);
+ 			err = ptr;
 		}
-		(void)strcpy(ptr, "\n");
 
+		err = NULL;
+		sprintf_alloc(&err,"%s\n",ptr);
+		free(ptr);
+		ptr = NULL;
 		if(use_syslog)
 			/* Include the sendmail queue ID in the log */
 			syslog(LOG_NOTICE, "%s: %s %s", privdata->envid, mess, err);
@@ -2511,9 +2495,10 @@
 static size_t
 clamfi_send(struct privdata *privdata, size_t len, const char *format, ...)
 {
-	char output[BUFSIZ];
+	char * output = NULL;
 	const char *ptr;
 	size_t numBytes = 0;
+	size_t ret_code = 0;
 
 	assert(format != NULL);
 
@@ -2527,7 +2512,9 @@
 		va_list argp;
 
 		va_start(argp, format);
-		vsnprintf(output, sizeof(output), format, argp);
+		vsprintf_alloc(&output, format, argp);
+		ALLOC_CHECK("vsprintf_alloc",output,1);
+			
 		va_end(argp);
 
 		len = strlen(output);
@@ -2587,13 +2574,22 @@
 #endif
 			}
 			checkClamd();
-
-			return -1;
+			ret_code = -1;
+			goto cleanup;
 		}
 		numBytes += nbytes;
 		privdata->numBytes += nbytes;
 		len -= nbytes;
 		ptr = &ptr[nbytes];
+	}
+cleanup:
+	if(output)
+		free(output);
+	if(ret_code){
+#ifdef CL_DEBUG
+		cli_dbgmsg("vsprintf_alloc: %s\n",output);
+#endif
+		return(-1);
 	}
 	return numBytes;
 }
